diff -ruN ../nakedmudv3.1/lib/pymodules/movement.py lib/pymodules/movement.py
--- ../nakedmudv3.1/lib/pymodules/movement.py	Wed Dec 31 17:00:00 1969
+++ lib/pymodules/movement.py	Sat Jul  1 20:07:04 2006
@@ -0,0 +1,216 @@
+################################################################################
+#
+# movement.py
+#
+# all of the functions concerned with movement and position change
+#
+################################################################################
+from mud import *
+from mudsys import add_cmd
+import inform, hooks
+
+
+
+# a ranking of positions
+positions     = ["unconcious", "sleeping", "sitting", "standing", "flying"]
+pos_act       = ["collapse",   "sleep",    "sit",     "stand",    "fly"]
+
+# stuff for handling movement
+dir_name = ["north", "east", "south", "west", "northeast", "northwest",
+                 "southwest", "southeast", "up", "down"]
+dir_abbr = ["n", "e", "s", "w", "ne", "nw", "sw", "se", "u", "d"]
+dir_opp  = [  2,   3,   0,   1,   6,     7,    4,    5,   9,   8]
+
+
+
+def try_use_furniture(ch, obj, pos):
+    '''attempts to resituate a person on the piece of furniture'''
+    # are we already on it?
+    if ch.on == obj:
+        ch.send("You are already " +ch.on.furniture_type+ " " +ch.on.name+ ".")
+    # make sure we have room
+    elif obj.furniture_capacity <= len(obj.chars):
+        ch.send("There isn't any room left.")
+    else:
+        # are we already on something? get up first
+        if ch.on:
+            message(ch,None,ch.on,None,True,"to_char","You stand up from $o.")
+            message(ch,None,ch.on,None,True,"to_room","$n stands up from $o.")
+            ch.on = None
+
+        # send our messages for sitting down
+        act = pos_act[positions.index(pos)]
+        message(ch, None, obj, None, True,
+                "to_char", "You " + act + " " + obj.furniture_type + " $o.")
+        message(ch, None, obj, None, True,
+                "to_room", "$n " + act + " " + obj.furniture_type + " $o.")
+
+        # place ourselves down on our new furniture
+        ch.on  = obj
+        ch.pos = pos
+        return True
+
+    # we didn't manage to get on the furniture
+    return False
+
+def try_change_pos(ch, pos):
+    '''this function attempts to change the position of the person'''
+    if ch.pos == pos:
+        ch.send("You are already " + pos + ".")
+        return False
+    else:
+        if ch.pos == "flying":
+            message(ch, None, None, None, True, "to_char", "You stop flying.")
+            message(ch, None, None, None, True, "to_room", "$n stops flying.")
+
+        act = pos_act[positions.index(pos)]
+        message(ch, None, None, None, True, "to_char", "You " + act + ".")
+        message(ch, None, None, None, True, "to_room", "$n "  + act + "s.")
+        ch.pos = pos
+        return True
+
+def cmd_sit(ch, cmd, arg):
+    '''attempts to sit'''
+    try:
+        obj, = parse_args(ch, True, cmd, arg, "| [on] obj.room")
+    except: return
+
+    if obj == None:
+        try_change_pos(ch, "sitting")
+    elif obj.istype("furniture"):
+        try_use_furniture(ch, obj, "sitting")
+    else:
+        ch.send("You cannot sit on " + inform.see_obj_as(ch, obj) + ".")
+
+def cmd_sleep(ch, cmd, arg):
+    '''attempts to sleep'''
+    try:
+        obj, = parse_args(ch, True, cmd, arg, "| [on] obj.room")
+    except: return
+
+    if obj == None:
+        try_change_pos(ch, "sleeping")
+    elif obj.istype("furniture"):
+        try_use_furniture(ch, obj, "sleeping")
+    else:
+        ch.send("You cannot sleep on " + inform.see_obj_as(ch, obj) + ".")
+
+def cmd_stand(ch, cmd, arg):
+    '''attempts to stand'''
+    try_change_pos(ch, "standing")
+
+def cmd_wake(ch, cmd, arg):
+    '''attempts to wake up'''
+    message(ch,None,None,None,True, "to_char", "You stop sleeping and sit up.")
+    message(ch,None,None,None,True, "to_room", "$n stops sleeping and sits up.")
+    ch.pos = "sitting"
+
+def dir_index(dir):
+    '''returns the index of the direction name'''
+    try:
+        return dir_name.index(dir)
+    except: pass
+    try:
+        return dir_abbr.index(dir)
+    except: pass
+    return -1
+
+def try_move_mssg(ch, dir):
+    '''Handles all moving of characters from one room to another, through
+       commands. Attempts a move. If succcessful, returns the exit left through.
+       Informs people of our moving'''
+    old_room = ch.room
+    ex       = try_move(ch, dir)
+    dirnum   = dir_index(dir)
+
+    # did we successfully move?
+    if ex != None:
+        new_room = ch.room
+        ch.room  = old_room
+
+        # send out our leave messages as needed
+        if ex.leave_mssg != '':
+            message(ch, None, None, None, True, "to_room", ex.leave_mssg)
+        elif dirnum == -1:
+            message(ch, None, None, None, True, "to_room", "$n leaves.")
+        else:
+            message(ch, None, None, None, True, "to_room",
+                    "$n leaves " + dir_name[dirnum] + ".")
+
+        # send out our enter messages as needed
+        ch.room = new_room
+        if ex.enter_mssg != '':
+            message(ch, None, None, None, True, "to_room", ex.enter_mssg)
+        elif dirnum == None:
+            message(ch, None, None, None, True, "to_room", "$n has arrived.")
+        else:
+            message(ch, None, None, None, True, "to_room",
+                    "$n arrives from the " + dir_name[dir_opp[dirnum]] + ".")
+
+    # return our exit, whether it existed or not
+    return ex
+
+def try_move(ch, dir):
+    '''Handles all moving of characters from one room to another, through
+       commands. Attempts a move. If succcessful, returns the exit left
+       through.'''
+    ex = ch.room.exit(dir)
+
+    # did we find an exit?
+    if ex == None or not ch.cansee(ex):
+        ch.send("Alas, there is no exit in that direction.")
+    elif ex.is_closed:
+        exname = ex.name
+        if exname == '':
+            exname = "it"
+        ch.send("You will have to open " + exname + " first.")
+    elif ex.dest == None:
+        ch.send("It doesn't look like " + exname + " leads anywhere!")
+    else:
+        old_room = ch.room
+
+        # run our leave hooks
+        hooks.run("exit", hooks.build_info("ch rm ex", (ch, ch.room, ex)))
+
+        ch.room = ex.dest
+        ch.act("look")
+
+        # run our enter hooks
+        hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
+
+    # return the exit we found (if we found any)
+    return ex
+
+def cmd_move(ch, cmd, arg):
+    '''cmd_move is the basic entry to all of the movement utilities. See
+       try_move() in movement.py'''
+    try_move_mssg(ch, cmd)
+
+
+
+################################################################################
+# mud commands
+################################################################################
+add_cmd("north",     "n",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("west",      "w",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("east",      "e",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("south",     "s",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("up",        "u",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("down",      "d",  cmd_move, "standing", "flying", "player", True, True)
+add_cmd("northwest", None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("northeast", None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("southwest", None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("southeast", None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("nw",        None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("ne",        None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("sw",        None, cmd_move, "standing", "flying", "player", True, True)
+add_cmd("se",        None, cmd_move, "standing", "flying", "player", True, True)
+
+add_cmd("wake",      None, cmd_wake,"sleeping","sleeping", "player", True, True)
+add_cmd("sleep",     None, cmd_sleep,"sitting", "flying",  "player", True, True)
+add_cmd("stand",     None, cmd_stand,"sitting", "flying",  "player", True, True)
+add_cmd("land",      None, cmd_stand, "flying", "flying",  "player", True, True)
+add_cmd("sit",       None, cmd_sit, "standing", "flying",  "player", True, True)
+
+# The mud needs to know our command for movement as well
+set_cmd_move(cmd_move)
diff -ruN ../nakedmudv3.1/lib/pymodules/utils.py lib/pymodules/utils.py
--- ../nakedmudv3.1/lib/pymodules/utils.py	Wed Dec 31 17:00:00 1969
+++ lib/pymodules/utils.py	Sat Jul  1 20:07:04 2006
@@ -0,0 +1,114 @@
+################################################################################
+#
+# utils.py
+#
+# Various utility functions used by other Python modules.
+#
+################################################################################
+
+def parse_keywords(kw):
+    '''turns a comma-separated list of strings to a list of keywords'''
+    list = kw.lower().split(",")
+    for i in range(len(list)):
+        list[i] = list[i].strip()
+    return list
+
+def is_one_keyword(kw, word, abbrev_ok = False):
+    '''returns whether or not the single word is a keyword in the list'''
+    for one_kw in kw:
+        if word == one_kw:
+            return True
+        elif abbrev_ok and len(one_kw)>len(word) and one_kw[0:len(word)]==word:
+            return True
+    return False
+            
+def is_keyword(kw, word, abbrev_ok = False):
+    '''returns whether or not the word (or list of words) is a keyword'''
+    kw   = parse_keywords(kw)
+    word = parse_keywords(word)
+
+    for one_word in word:
+        if is_one_keyword(kw, one_word, abbrev_ok):
+            return True
+    return False
+
+def has_proto(ch, proto):
+    '''returns whether or not the character has on his or her person an object
+       that inherits from the given prototype'''
+    for obj in ch.inv + ch.eq:
+        if obj.isinstance(proto):
+            return True
+    return False
+
+def find_all_objs(looker, list, name, proto = None, must_see = True):
+    '''returns a list of all the objects that match the supplied constraints'''
+    found = []
+    for obj in list:
+        if must_see and not looker.cansee(obj):
+            continue
+        elif name != None and is_keyword(obj.keywords, name, True):
+            found.append(obj)
+        elif proto != None and obj.isinstance(proto):
+            found.append(obj)
+    return found
+
+def find_obj(looker, list, num, name, proto = None, must_see = True):
+    '''returns the numth object to match the supplied constraints'''
+    count = 0
+    for obj in list:
+        if must_see and not looker.cansee(obj):
+            continue
+        elif name != None and is_keyword(obj.keywords, name, True):
+            count = count + 1
+        elif proto != None and obj.isinstance(proto):
+            count = count + 1
+        if count == num:
+            return obj
+    return None
+
+def get_count(str):
+    '''separates a name and a count, and returns the two'''
+    parts = str.lower().split(".", 1)
+
+    # did we get two, or one?
+    if len(parts) == 1 and parts[0] == "all":
+        return "all", ""
+    elif len(parts) == 1:
+        return 1, str
+
+    if parts[0] == "all":
+        return "all", parts[1]
+    try:
+        return int(parts[0]), parts[1]
+    except:
+        return 1, str
+
+def show_list(ch, list, s_func, m_func = None):
+    '''shows a list of things to the character. s_func is the description if
+       there is only a single item of the type. m_func is the description if
+       there are multiple occurences of the thing in the list'''
+
+    # maps descriptions to counts
+    counts = { }
+
+    # build up our counts
+    for thing in list:
+        if counts.has_key(s_func(thing)):
+            counts[s_func(thing)] = counts[s_func(thing)] + 1
+        else:
+            counts[s_func(thing)] = 1
+
+    # print out our counts
+    for thing in list:
+        # only display > 0 counts. Otherwise it has been displayed
+        if counts.has_key(s_func(thing)):
+            count = counts.pop(s_func(thing))
+
+            # display our item(s)
+            if count == 1:
+                ch.send(s_func(thing))
+            elif m_func == None:
+                ch.send("(" + str(count) + ") " + s_func(thing))
+            else:
+                ch.send(m_func(thing) % count)
+        else: pass
